/************************************************************************/

//			SARAH : a full linux gnome graphic files interface

//			What this name ?? why ??? you hate ???
//			Rev : 0.5

//			this implemant a widget for path browsing
//			currently depending to many function of this soft
//			THIS IS NOT A REAL GTK WIDGET

//			Author : J. LEVREAU (C)
//			E-mail : j.a.l@free.fr

//			Statut : free software for private use
//			This not a gpl soft : i create it so let me grow it !!!
//			( but you can use all you want / need without restrictions )

/************************************************************************/

#ifndef	GNOME_PATH_S
#define	GNOME_PATH_S

/************************************************************************/
#include	<gnome.h>
#include	<gtk/gtkhbox.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/************************************************************************/
//		structure definition
/************************************************************************/

#define GNOME_PATH(obj)         GTK_CHECK_CAST (obj, gnome_path_get_type (), GnomePath)
#define GNOME_PATH_CLASS(klass) GTK_CHECK_CLASS_CAST (klass, gnome_path_get_type (), GnomePathClass)
#define GNOME_IS_PATH(obj)      GTK_CHECK_TYPE (obj, gnome_path_get_type ())

typedef enum {
	GNOME_PATH_STATUS_OK,						// path ok / exist / have access right
//	GNOME_PATH_STATUS_DENIED,					// current path is denied
//	GNOME_PATH_STATUS_UNKNOW,					// invalid path
//	GNOME_PATH_STATUS_PREVIOUS,					// error on upper dir
	GNOME_PATH_STATUS_ERROR,					// bad request
	GNOME_PATH_STATUS_FIXED						// use parent of path request ( access ?? )
} GnomePathStatusEnum;

typedef enum {
	GNOME_PATH_CHANGE_TO_NEW,					// load a new path into widget
	GNOME_PATH_CHANGE_TO_CHILD,					// changed for a valid child ( may !direct child )
	GNOME_PATH_CHANGE_TO_PARENT,				// changed to parent dir ( may !direct parent )
	GNOME_PATH_CHANGE_NO_CHANGE,				// emit signal but yet on current path
//	GNOME_PATH_CHANGE_ERROR_FLAG = 1 << 15		// the current path is non valid
} GnomePathChangeEnum;

#define _GnomePath GnomePath;
#define _GnomePathClass GnomePathClass;

typedef struct {
	GtkHBox		b;
	
	GtkEntry	*e;								// path entry, don't call directly
	GtkButton	*status;						// show info about this current entry
	GtkPixmap	*icon;
	GtkButton	*parent;
	GtkButton	*child;
	
	gchar		*cp;							// for tempory work
	gchar		*oldpath;						// string math the old valid path used
} GnomePath;

typedef struct  {
	GtkHBoxClass parent_class;
	
	void (* path_changed)( GnomePath *w, GnomePathChangeEnum change );
} GnomePathClass;


/************************************************************************/
//	signal definition
/************************************************************************/
// 	there only one signal : "path_changed" :
//	callback form is :
//		void calllback( GnomePath *w, GnomePathChangeEnum change, gpointer user_data );

//	call this signal when a valid path is loaded by function, key string match


/************************************************************************/
// no comment
guint		gnome_path_get_type( void );
GnomePath	*gnome_path_new( void );			// create with root path ( "/" )

/************************************************************************/
// change the current path, fix it if wrong and flag set, call event if ok / fixed
GnomePathStatusEnum	gnome_path_set_path( GnomePath *w, gchar const *path, gboolean fix );

/************************************************************************/
// fix the current path to a valid path ( may no change so call event according to flag ),
// call event on fix ; return TRUE on change / event call
gboolean gnome_path_fix_path( GnomePath *w, gboolean always_event );

/************************************************************************/
// try to complete ( and not change to child... ) the current ( invalid ) path to a solution
// if solution is NULL, auto test ( may return a ( gchar *) / GList of solution
// if already valid, may also call event ( always_event )
// return NULL on no error ( or nothing to do ), -1 if there NO solution...
GList	*gnome_path_complete_path_with( GnomePath *w, gchar const *solution, gboolean always_event );

/************************************************************************/
// TRUE of ok
gboolean gnome_path_complete_fast_path_with( GnomePath *w, gchar const *solution, gboolean always_event );

/************************************************************************/
// change current entry to is parent ; in case of acces denied can fix it ( try until root dir )
// keep on current if there are no solution
GnomePathStatusEnum gnome_path_change_to_parent( GnomePath *w, gboolean fix );

/************************************************************************/
// to this child 
GnomePathStatusEnum gnome_path_change_to_child( GnomePath *w, gchar const *child );

// return the early valid path loaded, by default user directory ; always end with '/'
gchar *gnome_path_get_path( GnomePath *w );

/************************************************************************/
// return the current content of entry widget, may wrong ; always end with '/'
gchar *gnome_path_get_widget_path( GnomePath *w );

/************************************************************************/
// return the early valid path loaded, so as above but return const :
// don't free it and use it for quick function ( that don't risk to call gnome_path )
gchar const *gnome_path_get_path_fast( GnomePath *w );

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif	GNOME_PATH_S
